{bot}
{auth is an authentication service primerally intended for use with quakenets}
{lightweight this can be obtained from cvs.quakenet.org}
{auths default nick is A}

(*
 *  beware IRC services, authbot.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  modifications by peter green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit authbot;

interface

uses authaccount,buser,bconsts,pgmail,sysutils,pgdebugout,bircrandom,pgtypes;

const
  commandsfile='auth.com.ini';
  configfile='auth.ini';
  cfgtag='[Auth]';
  accountsfile='auth.accounts.ini';
  emailbanfile='auth.emailban.ini';

  Authbotlogfile='auth.log';
  authmailfile='authmail.txt';
  requestpassmailfile='requestpassmail.txt';

procedure onsendburst(tag:taddrint);
procedure ondisconnect(tag:taddrint);
procedure onstartup(tag:taddrint);
procedure authbotshutdown(tag:taddrint);
procedure ontimer(tag:taddrint);
procedure onaccount(sptr:tuser;us:tuser;tag:taddrint);
procedure ondestroyuser(us:tuser;tag:taddrint);
procedure onrehash(tag:taddrint);

procedure savecmd;
procedure loadcmd;
function validcomname(s:string):boolean;

procedure deauth(us:tuser);

var
  mybot:tuser;  {this unit has one bot, pointer to tuser for bot}
type
  trequestmailsession = class
    account : string;
    client  : string;
    procedure mailfinished(reply : string);
  end;
  tnewpassmailsession = class
    account : string;
    client  : string;
    procedure mailfinished(reply : string);
  end;

var
  locopt:record
    nick:string;
    userid:string;
    info:string;
    operchannel:string;
    operlevel:integer;
    securelogin:boolean;
    maxlogins:integer;
    accountlen:integer;
    accountchars:string;
    nickserv:boolean;
    emailreg   : boolean;
    mailserver : string;
    fromemail:string;
    fromemailrealname:string;
    mailthrottle:integer;
    registerthrottle:integer;
  end;

{==============================================================================}
implementation

uses
  bconfig,bservicemngr,bparse,bcmds,bstuff,bchannel,btime,{b_gline,}passcryp,
  blinklist,bcrash,bservunit,unitbanmask,readtxt,boptiontable,
  authipthrottle,bsetcommand,authemailban,bworldauthstuff,unitwritetxt;

{info commands}
procedure priv_showcommands(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;


procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{own account}
procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;msg:string);forward;}
procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_drop(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_nickkill(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{global bot management}
procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_chinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_chsyntax(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

procedure priv_mkpasswd(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{user accounts management}
procedure priv_adduser(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_deluser(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_userlist(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_userinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_moduser(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

procedure priv_hello(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_requestpassword(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;



{centralized error replies}
function error_nosuchaccount(const name:string):string;
begin
  result := 'No such account: '+name;
end;

function error_nosuchchannel(const name:string):string;
begin
  result := 'No such channel: '+name;
end;

function error_nosuchnick(const name:string):string;
begin
  result := 'No such nick: '+name;
end;

type
  taccount=class
    name:string;
    info:string;
    password:string; {crypted password using salt MD5}
    level:integer;
    user:tuser; {who is logged in; only one for now, call to ondestroyuser is needed at the begin of tuser.destroy}
  end;

var
  cmd:string; {currently called cmd}
  nickatservervar:boolean;
  autosavenextts:integer;

{level -1 = always allow, even if not logged in}

const
  botmaxcmd=22;

var
// %nick% in the info or syntax field is replaced with the bots nick
// %server% in the info or syntax field is replaced with the services servers name
// %cmd% in the info or syntax field is replaced with the name of the command
// %newline% in the info or syntax field signifies a new line  note : useing this in
// the info field will really screw up the formatting of the help reply it is
// really intended for the syntax field
// btw with theese chars i'm trying to stick to chars which are typeable but
// are obscure enough not to be likely to cause a problem :)

cmdtab:array[0..botmaxcmd] of tcmdtab=(

(
cmd:'LOGIN';
level:-1;
p:priv_login;
minparams:3;
info:'Logs you in to your account';
syntax:'type /msg %nick%@%server% %cmd% <username> <password>'),
(
cmd:'HELLO';
level:-1;
p:priv_hello;
minparams:4;
info:'Creates a new account';
syntax:'type /msg %nick% %cmd% <an account name> <your email address> <repeat email address>'),
(
cmd:'HELP';
level:-1;
p:priv_showcommands;
minparams:1;
info:'Displays this list of commands, and get more help about a command';
syntax:'type /msg %nick% %cmd% [<command>]'),
(
cmd:'REQUESTPASSWORD';
level:-1;
p:priv_requestpassword;
minparams:2;
info:'For when you have lost your password';
syntax:'type /msg %nick% %cmd% <your email address>'),
(
cmd:'NICKKILL';
level:0;
p:priv_nickkill;
minparams:1;
info:'Kills a connection using your nick';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'NEWPASS';
level:0;
p:priv_newpass;
minparams:4;
info:'Changes your existing password to a new one';
syntax:'type /msg %nick% %cmd% <oldpass> <newpass> <newpass>'),
(
cmd:'DROP';
level:0;
p:priv_drop;
minparams:3;
info:'Deletes your %nick% account';
syntax:'type /msg %nick% %cmd% <myusername> <mypassword>'),
(
cmd:'MKPASSWD';
level:10;
p:priv_mkpasswd;
minparams:2;
info:'Encrypts a password.';
syntax:'type /msg %nick% %cmd% <password>'),
(
cmd:'USERLIST';
level:100;
p:priv_USERlist;
minparams:1;
info:'Lists user accounts. (parameters minlevel maxlevel)';
syntax:'%type /msg %nick% cmd% [<minlevel>] maxlevel'),
(
cmd:'USERINFO';
level:100;
p:priv_USERinfo;
minparams:2;
info:'Displays information about an account.';
syntax:'type /msg %nick% %cmd% <username>'),

(
cmd:'ADDUSER';
level:800;
p:priv_addUSER;
minparams:3;
info:'Creates a new user account.';
syntax:'type /msg %nick% %cmd% <username> <level>'),
(
cmd:'DELUSER';
level:800;
p:priv_delUSER;
minparams:2;
info:'Deletes an existing account.';
syntax:'type /msg %nick% %cmd% <username>'),
(
cmd:'MODUSER';
level:800;
p:priv_modUSER;
minparams:3;
info:'Modify''s a users account';
syntax:'type /msg %nick% %cmd% <username> <command> [<param>]%newline%commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY EMAIL'),

(cmd:'REHASH';
level:900;
p:priv_rehash;
minparams:1;
info:'Reloads the config and account data from HD.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'SAVE';
level:900;
p:priv_save;
minparams:1;
info:'Saves the config and account data to HD.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'RESTART';
level:900;
p:priv_restart;
minparams:1;
info:'Restarts %nick%.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'DIE';
level:900;
p:priv_die;
minparams:1;
info:'terminates bewareserv.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'DIEBOT';
level:900;
p:priv_diebot;
minparams:1;
info:'Stops only %nick%.';
syntax:'type /msg %nick% %cmd%'),

(
cmd:'CHLEVEL';
level:1000;
p:priv_level;
minparams:1;
info:'Changes the access level of a command.';
syntax:'%cmd% [<command>] [<level>]'),
(
cmd:'CHCOMNAME';
level:1000;
p:priv_chcomname;
minparams:3;
info:'Changes the name of a command.';
syntax:'%cmd% <old command name> <new command name>'),
(cmd:'CHINFO';
level:1000;p:priv_chinfo;
minparams:3;
info:'Changes the info field for a command.';
syntax:'%cmd% <command> <new info setting>'),
(
cmd:'CHSYNTAX';
level:1000;
p:priv_chsyntax;
minparams:3;
info:'Changes the syntax field for a command.';
syntax:'%cmd% <command> <new syntax setting>'),

(
cmd:'SET';
level:1000;
p:priv_set;
minparams:1;
info:'Changes or views %nick% configuration.';
syntax:'%cmd% <option> [<new value>|none]')
);



const
  maxoptiontable=15;

var
  optiontable:array[0..maxoptiontable] of Toptionentry=(
  (
  p:@locopt.nick;
  typ:opt_str;
  name:'nick';
  info:'auth bot''s nick';
  def_s:'A'),
  (
  p:@locopt.userid;
  typ:opt_str;
  name:'userid';
  info:'auth bot''s userid (empty for global userid setting)';
  def_s:''),
  (
  p:@locopt.info;
  typ:opt_str;
  name:'info';
  info:'auth bot''s realname';
  def_s:'beware IRC authentication Service'),
  (
  p:@locopt.operchannel;
  typ:opt_str;
  name:'operchannel';
  info:'authbot event log channel';
  def_s:'#Admin'),
  (
  p:@locopt.operlevel;
  typ:opt_int;
  name:'OperLevel';
  info:'Auth bot access level for opers who are not logged in';
  def_i:maxlevel div 10),
  (
  p:@locopt.securelogin;
  typ:opt_bool;
  name:'securelogin';
  info:'require "/msg nick@server login"';
  def_b:true),
  (
  p:@locopt.maxlogins;
  typ:opt_int;
  name:'maxlogins';
  info:'maximum number users who can be logged in to one account';
  def_i:2),
  (
  p:@locopt.accountlen;
  typ:opt_int;
  name:'AccountLen';
  info:'maximum length of account name.';
  def_i:12),
  (
  p:@locopt.accountchars;
  typ:opt_str;
  name:'AccountChars';
  info:'allowed characters in account name, for first char, for other chars. A means A-Z, etc';
  def_s:'Aa0 Aa0'),
  (
  p:@locopt.nickserv;
  typ:opt_bool;
  name:'NickServ';
  info:'Enable NickServ functionality.';
  def_s:'Aa0 Aa0'),
  (
  p:@locopt.emailreg;
  typ:opt_bool;
  name:'emailreg';
  info:'use email for registration';
  def_b:false),
  (
  p:@locopt.mailserver;
  typ:opt_str;
  name:'mailserver';
  info:'SMTP server to use for sending account registration mails';
  def_s:'127.0.0.1'),
  (
  p:@locopt.fromemail;
  typ:opt_str;
  name:'fromemail';
  info:'source email address which appears in emails sent by auth service';
  def_s:'authservice@localhost'),
  (
  p:@locopt.fromemailrealname;
  typ:opt_str;
  name:'fromemailrealname';
  info:'"real name" for source email address';
  def_s:'Auth service'),
  (
  p:@locopt.mailthrottle;
  typ:opt_int;
  name:'MailThrottle';
  info:'minimum time in seconds between 2 password mails to one account';
  def_i:3600),
  (
  p:@locopt.registerthrottle;
  typ:opt_int;
  name:'RegisterThrottle';
  info:'minimum time in seconds between 2 account registration attempts from one IP';
  def_i:86400)
  );

  up:boolean;   {the service unit is enabled}

  srvunit:tserviceunit;
  currentoperchannel:string;
  sendtalk:string;
  prefix:string;  {the ":sender " part of a message sent by this bot}



function levelcontrol(mylevel,otherlevel:integer):boolean;
begin
  if mylevel >= maxlevel then begin
    result := mylevel >= otherlevel;
  end else begin
    result := mylevel > otherlevel;
  end;
end;

function getaccountfromuser(us:tuser):taaccount;
begin
  result := us.bottag[srvunit.num];
end;

function haslevel(us:tuser):integer;
var
  p:tAaccount;
begin
  result := -1;
  if isoper(us) then result := locopt.operlevel;
  p := getaccountfromuser(us);
  if p <> nil then begin
    if p.level > result then result := p.level;
  end;
end;

procedure logaction(sptr:tuser;s:string);
var
  from:string;
  p:tAaccount;
begin

  if sptr <> nil then begin
    from := nickuserhost(sptr)+'['+ipbintostr(sptr.binip)+']';
    p := getaccountfromuser(sptr);
    if p <> nil then begin
      from := from + '('+p.name+')';
    end;
    from := from + ' ';
  end else begin
    from := '';
  end;

  if currentoperchannel <> '' then send(prefix+TOK_NOTICE+' '+currentoperchannel+' :'+from+s);
  filelog(Authbotlogfile,from+s);
end;

procedure deauth(us:tuser);
var
  t:tAaccount;
begin
  t := getaccountfromuser(us);
  if t = nil then exit;

  assert(t.removeuser(us),'Auth.deauth: user not in account','');
  us.bottag[srvunit.num] := nil;
  t.lastseents := unixtime;

  if up then if not flag_isset(us.flags,userflag_destroying) then sendkill(us,mybot.name,'deauth');

  us.bottag[srvunit.num] := nil;
end;

function getloginname(us:tuser):string;
var
  t:tAaccount;
begin
  result := '';
  t := getaccountfromuser(us);
  if t = nil then exit;
  result := t.name;
end;

procedure authbotinit;
begin
  {fill in some defaults in case they cant be read from config file}

  optiontable_default(optiontable,maxoptiontable);
  optiontable_load(optiontable,maxoptiontable,configfile,cfgtag);

  loadcmd;
  updatevalidaccounttable;
  loadAaccount(accountsfile);
  loademailban(emailbanfile);
  autosavenextts := unixtime+opt.autosave;
end;

procedure authbotsave;
{var
  t:textfile;}
begin
  autosavenextts := unixtime+opt.autosave;
  savecmd;
  saveAaccount(accountsfile);
  saveemailban(emailbanfile);
  optiontable_save(optiontable,maxoptiontable,configfile,cfgtag);
end;

procedure onsave(tag:taddrint);
begin
  logaction(nil,'Received SAVE signal');
  authbotsave;
end;

procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
  p:tAaccount;
  sl:tstringlinklist;
  s1,s2,s3:string;
  pp:tplinklist;

begin
  {
  check:
  - is already logged in to anything
  - someone is already logged in to account
  - is ircop
  - mask
  - password.

  then associate user with account and account with user
  }

  if locopt.securelogin then if not nickatservervar then begin
    send(sendtalk+'To use LOGIN, you must /msg '+mybot.name+'@'+me.name);
    exit;
  end;

  {if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <username> <password>');
    exit;
  end;}

  if sptr.account <> '' then begin
    send(sendtalk+'Sorry, You are already authenticated as '+sptr.account);
    exit;
  end;

  p := findAaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+'AUTHENTICATION FAILED as '+parv[1]+'. Account does not exist.');
    exit;
  end;

  {if operonly: check}
  if not isoper(sptr) then if p.operonly then begin
    logaction(sptr,'Failed login to '+p.name+': not IRCop');
    send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. You''re not IRC Operator.');
    exit;
  end;

  if (p.password = '') then begin
    logaction(sptr,'Failed login to '+p.name+': account disabled.');
    send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Account disabled.');
    exit;
  end;

  s1 := sptr.name+'!'+sptr.userid+'@'+sptr.host;
  s2 := sptr.name+'!'+sptr.userid+'@'+ipbintostr(sptr.binip);
  sl := p.mask;
  a := 0;
  while sl <> nil do begin
    s3 := sl.s;
    if maskmatchup(s3,s1) or maskmatchup(s3,s2) then begin
      a := 1;
      break;
    end;
    sl := tstringlinklist(sl.next);
  end;
  if a = 0 then begin
    logaction(sptr,'Failed login to '+p.name+': mask does not match');
    send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Your mask does not match.');
    exit;
  end;

  if not authaccountpasswordmatch(p,parv[2]) then begin
    logaction(sptr,'Failed login to '+p.name+', Password incorrect.');
    send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Password incorrect.');
    exit;
  end;

  if locopt.maxlogins > 0 then if not isoper(sptr) then begin
    a := 0;
    pp := p.user;
    s1 := '';
    while pp <> nil do begin
      inc(a);
      s1 := s1 + ' '+nickuserhost(tuser(pp.p));
      pp := tplinklist(pp.next);
    end;
    if a >= locopt.maxlogins then begin
      send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Maximum concurrent logins exceeded.');
      send(sendtalk+'Current Sessions:'+s1);
      exit;
    end;
  end;

  pp := p.user;
  while pp <> nil do begin
    send(sendprefixstr(mybot)+TOK_NOTICE+' '+tuser(pp.p).idstr+' :'+nickuserhost(sptr)+' logged in to your account.');
    pp := tplinklist(pp.next);
  end;

  sendparse(me.idstr+' '+TOK_ACCOUNT+' '+sptr.idstr+' '+ parv[1]);
  send(sendtalk+'AUTHENTICATION SUCCESSFUL as '+p.name+'.');

  p.requestedpass := '';
  p.password := passnewcrypt(parv[2]);

  if p.level = 0 then p.level := 1;
(*  logaction(sptr,'LOGIN');*)

end;

procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;

begin
  {if (parv[3] = '') or (parc < 4) then begin
    send(sendtalk+cmd+' <old> <new> <new>');
    exit;
  end;}

  p := getaccountfromuser(sptr);
  if p = nil then begin
    send(sendtalk+'You are not logged in.');
    exit;
  end;

  if (not authaccountpasswordmatch(p,parv[1])) then begin
    send(sendtalk+'password incorrect');
    exit;
  end;

  if (parv[2] <> parv[3]) then begin
    send(sendtalk+'new password mismatch');
    exit;
  end;

  if ircupper(parv[4])='PRECRYPT' then begin
    p.password := parv[3];
  end else begin
    p.password := passnewcrypt(parv[3]);
  end;


  logaction(sptr,'NEWPASS');
  send(sendtalk+'Your password has been changed.');
end;

procedure priv_drop(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;
begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+' To remove your account, type /msg A '+cmd+' <myusername> <mypassword>');
    exit
  end;}
  p := findAaccount(parv[1]);
  if p <> getaccountfromuser(sptr) then begin
    send(sendtalk+'you can only drop your own account');
    exit;
  end;

  if getaccountfromuser(sptr) = nil then begin
    {this code will only run if the admin is a lamer and makes drop availablie to level -1 users}
    send(sendtalk+'you are not logged in');
    exit;
  end;

  if not authaccountpasswordmatch(p,parv[2]) then begin
    send(sendtalk+'password incorrect.');
    exit;
  end;

  send(sendtalk+'Your account has been deleted.');

  logaction(sptr,cmd+' '+p.name);
  linklistdel(tlinklist(Aaccountlist),tlinklist(p));
  p.destroy;

  {}
end;

procedure priv_nickkill(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  us:tuser;
begin
  if not locopt.nickserv then begin
    send(sendtalk+'function disabled.');
    exit;
  end;

  if (getaccountfromuser(sptr) = nil) then begin
    send(sendtalk+'You are not logged in');
    exit;
  end;

  us := findnick(getaccountfromuser(sptr).name);

  if us = nil then begin
    send(sendtalk+'No one is using your nick.');
    exit;
  end;

  if us = sptr then begin
    send(sendtalk+'You are using the nick yourself.');
    exit;
  end;

  sendkill(us,sptr.name,'NickServ kill');
  send(sendtalk+'User using your nick has been killed.');
end;

{procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;msg:string);
begin

  if sptr.bottag[srvunit.num] = nil then begin
    send(sendtalk+'You are not logged in.');
    exit;
  end;

  deauth(sptr);
  send(sendtalk+'You are logged off.');
end; }


{===================================================================== info commands}



procedure priv_showcommands(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a,b,c:integer;
  s:string;
begin
  parv[1] := ircupper(parv[1]);
  if parc >=2 then begin
    for a := 0 to botmaxcmd do begin
      if parv[1] = cmdtab[a].customcmd then begin
        if haslevel(sptr) >= cmdtab[a].level then begin
          send(sendtalk+replacespecial(cmdtab[a].syntax,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk));
          exit;
        end;
      end;
    //if bool then exit; {LOGIN must be first entry of cmdtable}
    end;
  end;
  send(sendtalk+'The following commands are available to you:');
  send(sendtalk+'use /msg '+mybot.name+' help <command> for help on a specific command');
  send(sendtalk+'--------------------------------------------');
  b := haslevel(sptr);
  c := 1;
  for a := 0 to botmaxcmd do if b >= cmdtab[a].level then begin
    if length(cmdtab[a].customcmd) > c then c := length(cmdtab[a].customcmd);
  end;
  for a := 0 to botmaxcmd do begin
    if b >= cmdtab[a].level then begin
  (*      s := s+cmdtab[a].customcmd+' ';
        if length(s) > 50 then begin
          send(sendtalk+s);
          s := '';
        end*)
        s := cmdtab[a].customcmd;

      while length(s) < c do s := s + ' ';
      if b >= 10 then begin
        send(sendtalk+s+' '+replacespecial(cmdtab[a].info,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk)+' '+inttostr(cmdtab[a].level));
      end else begin
        send(sendtalk+s+' '+replacespecial(cmdtab[a].info,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk));
      end;
    end;
  end;
  {  if s <> '' then send(sendtalk+s);}


end;

procedure priv_lusers(sptr:tuser;parc:integer;parv:pparams;msg:string);
begin
  send(sendtalk+'There are '+
  inttostr(count.globalclients-count.invisible)+' users and '+
  inttostr(count.invisible)+' invisible on '+
  inttostr(count.globalservers)+' servers');
  send(sendtalk+inttostr(count.globalclients)+' global users');

  send(sendtalk+inttostr(count.oper)+' operator(s) online');
  send(sendtalk+inttostr(count.channels)+' channels formed');
end;

{========================================================================= misc}


function lastparam(parv:pparams;parc,first:integer):string;
var
  a:integer;
begin
  result := '';
  for a := first to parc-1 do begin
    if result <> '' then result := result + ' ';
    result := result +parv[a];
  end;
end;


{
onsavefile(from:tuser;,filename:string)

can be used to have multiple bots use the same file for something;
one bot saves, another bot loads

}

procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
begin
  setcommand(sptr,parc,parv,msg,authbot.optiontable,authbot.maxoptiontable,sendtalk,cmd,s);
  if s <> '' then logaction(sptr,s);
end;


procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  logaction(sptr,cmd);
  authbotsave;
end;

procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  logaction(sptr,cmd);
  authbotinit;
end;

procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  logaction(sptr,cmd);
  authbotshutdown(srvunit.tag);
  onstartup(srvunit.tag);
end;

procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  {onshutdown;}
  {die does global shutdown atm}
  globalshutdown;
  halt;
end;

procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  authbotshutdown(srvunit.tag);
end;

procedure priv_mkpasswd(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  {if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' <password>');
    exit;
  end;                                }
  send(sendtalk+passnewcrypt(parv[1]));
end;

{=======================================================================commands management}

function validcomname(s:string):boolean;
var
  a:integer;
begin
  result := false;
  if (length(s) > 15) or (s = '') then exit;
  for a := 1 to length(s) do if not (s[a] in ['A'..'Z']) then exit;
  result := true;
end;

procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a,b:integer;
  s:string;
begin
  if (parc < 2) or (parv[1] = '') then begin
    s := '';
    for a := 0 to botmaxcmd do begin
      s := s + cmdtab[a].cmd+'='+inttostr(cmdtab[a].level)+'    ';
      if length(s) > 50 then begin
        send(sendtalk+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+s);
    exit
  end;
  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].cmd = parv[1] then begin
      if (parc > 2) and (parv[2] <> '') then
      b := strtointdef(parv[2],-2)
      else b := -2;
      if b > -2 then begin
        logaction(sptr,cmd+' '+cmdtab[a].cmd+' '+inttostr(cmdtab[a].level)+' -> '+inttostr(b));
        cmdtab[a].level := b;
      end else begin
        send(sendtalk+cmdtab[a].cmd+'='+inttostr(cmdtab[a].level));
      end;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;

procedure savecmd;
var
  t:textfile;
  a:integer;
begin
  if not openforwrite(t,commandsfile) then exit;
  writeln(t,'[Auth.commands]');
  for a := 0 to botmaxcmd do begin
    writeln(t,'name='+cmdtab[a].cmd);
    writeln(t,'customname='+cmdtab[a].customcmd);
    writeln(t,'level='+inttostr(cmdtab[a].level));
    writeln(t,'enabled='+inttostr(ord(cmdtab[a].enabled)));
    writeln(t,'info='+cmdtab[a].info);
    writeln(t,'syntax='+cmdtab[a].syntax);
    writeln(t);
  end;
  closefile(t);
end;

var
  currentloadcmd:integer;

procedure loadcmdproc(sv,sn:string);
var
  a:integer;
begin
  if sv = 'NAME' then begin
    sn := ircupper(sn);
    currentloadcmd := -1;
    for a := 0 to botmaxcmd do if cmdtab[a].cmd = sn then begin
      currentloadcmd := a;
      exit;
    end;
  end else
  if sv = 'CUSTOMNAME' then begin
    if currentloadcmd <> -1 then begin
      sn := ircupper(sn);
      if validcomname(sn) then cmdtab[currentloadcmd].customcmd := sn;
    end;
  end else
  if sv = 'LEVEL' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].level := strtointdef(sn,maxlevel);
    end;
  end else
  if sv = 'ENABLED' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].enabled := sn = '1';
    end;
  end else if sv = 'INFO' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].info := sn;
    end;
  end else if sv = 'SYNTAX' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].syntax := sn;
    end;
  end;
end;

procedure loadcmd;
var
  a:integer;
begin
  currentloadcmd := -1;
  for a := 0 to botmaxcmd do begin
    cmdtab[a].customcmd := cmdtab[a].cmd;
    cmdtab[a].enabled := true;
  end;
  readcfg(commandsfile,@loadcmdproc);
end;

procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <old command name> <new command name>');
    exit
  end;}
  parv[1] := ircupper(parv[1]);
  parv[2] := ircupper(parv[2]);

  {check for parv[2] be a valid command (that is, easy to type)}

  if not validcomname(parv[2]) then begin
    send(sendtalk+'bad command name');
    exit
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[2] then begin
      send(sendtalk+'command '+parv[2]+' already exists, can''t change.');
      exit;
    end;
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+parv[2]);
      cmdtab[a].customcmd := parv[2];
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;

procedure priv_chinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
  s:string;
begin
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);

  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+s);
      cmdtab[a].info := s;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;

procedure priv_chsyntax(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
  s:string;
begin
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);

  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+s);
      cmdtab[a].syntax := s;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;
{========================================================================user account}

procedure priv_adduser(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;
  s:string;
  a:integer;
begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <username> <level>');
    exit
  end;}

  s := convertaccountname(parv[1]);

  if not validaccountname(s) then begin
    send(sendtalk+'invalid username');
    exit
  end;
  a := strtointdef(parv[2],-1);
  if a < 0 then begin
    send(sendtalk+'invalid level');
    exit;
  end;
  p := findAaccount(parv[1]);

  if p <> nil then begin
    send(sendtalk+'account '+p.name+' already exists.');
    exit;
  end else begin
    if not levelcontrol(haslevel(sptr),a) then begin
      if a > haslevel(sptr) then begin
        send(sendtalk+'can''t add an account with this level.');
        exit;
      end;
    end;

    p := addAaccount(parv[1],a);
    p.lastmailts := unixtime;
    logaction(sptr,cmd+' '+parv[1]+' '+inttostr(a));
  end;
end;

procedure priv_deluser(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;
begin
  if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' <username>');
    exit
  end;
  p := findAaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;

  if not levelcontrol(haslevel(sptr),p.level) then begin
    send(sendtalk+'No access to delete an account with this level');
    exit;
  end;

  logaction(sptr,cmd+' '+p.name);
  linklistdel(tlinklist(Aaccountlist),tlinklist(p));
  p.destroy;

end;

procedure priv_moduser(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;
  s,subcmd:string;
  a:integer;
begin
  {if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <username> <command> [<param>]');
    send(sendtalk+cmd+' commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY EMAIL');
    exit
  end;}
  p := findAaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;

  if not levelcontrol(haslevel(sptr),p.level) then begin
    send(sendtalk+'No access to modifying an account with this level');
    exit;
  end;

  subcmd := ircupper(parv[2]);
  if subcmd = 'ADDMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if not validmask(s) then begin
        send(sendtalk+'invalid mask');
      end else begin
        if p.addmask(s) then begin
          logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
        end else begin
          send(sendtalk+'mask already exists');
        end;
      end;
    end;
  end else if subcmd = 'DELMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if p.delmask(s) then begin
        logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
      end else begin
        send(sendtalk+'mask does not exist');
      end;
    end;
  end else if pos('PASS',subcmd) <> 0 then begin
    if parv[3] = '' then begin
      logaction(sptr,'Account '+p.name+' disabled.');
      p.password := '';
    end else begin
      logaction(sptr,cmd+' NEWPASS '+p.name);
      if ircupper(parv[4])='PRECRYPT' then begin
        p.password := parv[3];
      end else begin
        p.password := passnewcrypt(parv[3]);
      end;
    end;
  end else if subcmd = 'LEVEL' then begin
    a := strtointdef(parv[3],-1);
    if a >= 0 then begin
      if not levelcontrol(haslevel(sptr),a) then begin
        send(sendtalk+'can''t change level to this');
        exit;
      end;
      logaction(sptr,cmd+' LEVEL '+p.name+' '+inttostr(p.level)+' -> '+inttostr(a));
      p.level := a;
    end;
  end else if subcmd = 'OPERONLY' then begin
    s := ircupper(parv[3]);
    if ((s = 'ON') or (s = '1')) and (not p.operonly) then begin
      logaction(sptr,cmd+' operonly '+p.name+' ON');
      p.operonly := true
    end else if ((s = 'OFF') or (s = '0')) and (p.operonly) then begin
      logaction(sptr,cmd+' operonly '+p.name+' OFF');
      p.operonly := false ;
    end;
  end else if pos('EMAIL',subcmd) <> 0 then begin

    logaction(sptr,'Account '+p.name+' email set to '+parv[3]);
    p.email := parv[3];

  end else begin
    send(sendtalk+'invalid command');
  end;
end;

procedure priv_userlist(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;
  s:string;
  a,b,minlevel,maxlevel:integer;
begin
  minlevel := -maxlongint;
  maxlevel := maxlongint;
  if (parv[1] <> '') and (parc > 1) then minlevel := strtointdef(parv[1],-maxlongint);
  if (parv[2] <> '') and (parc > 2) then maxlevel := strtointdef(parv[2],maxlongint);

  p := Aaccountlist;
  send(sendtalk+'  username        level    online');
  a := 0;
  b := 0;
  while p <> nil do begin
    if (p.level >= minlevel) and (p.level <= maxlevel) then begin
      s :=  '    '+p.name+' ';
      while length(s) < 20 do s := s + ' ';
      s := s + inttostr(p.level)+' ';
      while length(s) < 29 do s := s + ' ';
      if p.user <> nil then begin
        s := s + tuser(p.user.p).name;
      end else begin
        s := s + '-';
      end;
      send(sendtalk+s);
      inc(a);
    end;
    inc(b);
    p := tAaccount(p.next);
  end;
  send(sendtalk+'--- End of list, '+inttostr(a)+' of '+inttostr(b)+' accounts shown.');
  {}
end;

procedure priv_userinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);

function agostr(a:integer):string;
begin
  result := inttostr(a div 86400)+' days, '+inttostr((a div 3600) mod 24)+' hours, '+inttostr(a mod 3600)+' seconds';
end;

var
  p:tAaccount;
  s:string;
  sl:tstringlinklist;
  pp:tplinklist;
  a:integer;
begin
  {if (parc < 2) or (parv[2] = '1') then begin
    send(sendtalk+cmd+' <username>');
    exit;
  end;}
  p := findAaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;
  send(sendtalk+'  Name: '#2+p.name+#2'    Level: '#2+inttostr(p.level)+#2);

  if p.email <> '' then send(sendtalk+'  email: '#2+p.email+#2);
  if p.hellouser <> '' then send(sendtalk+'  registered by: '#2+p.hellouser+#2);
  sl := p.mask;
  if sl <> nil then begin
    s := '';
    while (sl <> nil) do begin
      s := s + ' '+sl.s;
      sl := tstringlinklist(sl.next);
      if length(s) > 450 then begin
        send(sendtalk+'  masks:'#2+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  masks:'#2+s);

  end else begin
    send(sendtalk+'  no masks.');
  end;

  if p.user = nil then begin
    send(sendtalk+'  Not logged in.');
    if p.lastseents <> 0 then begin
      a := unixtime - p.lastseents;
      send(sendtalk+'  last seen '+agostr(a)+' ago.');
    end else if (p.lastmailts <> 0) then begin
      a := unixtime - p.lastmailts;
      send(sendtalk+'  created: '+agostr(a)+' ago.');
    end;
  end else begin
    pp := p.user;
    while pp <> nil do begin
      send(sendtalk+'  Logged in: '#2+nickuserhost(tuser(pp.p)));
      pp := tplinklist(pp.next);
    end;
  end;

  if p.operonly then send(sendtalk+'  Must be IRCop to log in');
  if p.password = '' then send(sendtalk+'  Account disabled.');

  send(sendtalk+'--- End of info ---');
  {}
end;

// this does a case insensitive compare due to the fact it is designed to
// be used in abuse checking
function compareemail(a,b : string; compareserveronly : boolean) : boolean;
begin
  if compareserveronly then begin
    a:= copy(a,pos('@',a)+1,32767);
    b:= copy(a,pos('@',a)+1,32767);

  end;
  result := strcompup(a,b);
end;




function randompassword:string;
begin
  result := p10inttostr(ircrandom and $3FFFFFFF,5) + p10inttostr(ircrandom and $3FFFF,3);
end;

procedure priv_hello(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;
  s:string;
  a:integer;
  password : string;
  mail : trequestmailsession;
  emailusername  : string;
  emaildomain    : string;
  counter        : word;
  atfound     : boolean;
  currentpartlen : word;
  longpartcount  : word;

  mailtext:string;
  fromstr:string;
  Pt:treadtext;
  sl:tstringlinklist;
begin

  if (parc < 4) or (parv[3] = '') then begin
    {if locopt.emailreg then begin
      send(sendtalk+'To create an account type /msg '+mybot.name+' '+cmd+' <an account name> <my e-mail address> <my e-mail address again> (For example /msg '+mybot.name+' memzy me@myisp.com me@myisp.com )');
    end else begin
      send(sendtalk+'To create an account
      end;
    exit}
  end;

  a := authipthrottle_find(sptr.binip) + locopt.registerthrottle - unixtime;
  if a > 0 then begin
    send(sendtalk+'You can''t register an account from your IP now. Please wait '+inttostr(a)+' seconds.');
    exit;
  end;

  if locopt.nickserv then if not strcompup(parv[1],sptr.name) then begin
    send(sendtalk+'Use your nick as username.');
    exit;
  end;

  s := convertaccountname(parv[1]);

  if not validaccountname(parv[1]) then begin
    send(sendtalk+'invalid username');
    exit
  end;

  if parv[2] <> parv[3] then begin
    if locopt.emailreg then begin
      send(sendtalk+'you must type the same email address twice for verification')
    end else begin
      send(sendtalk+'you must type the same password twice for verification');
    end;
    exit
  end;

  atfound := false;
  emailusername := '';
  emaildomain   := '';
  currentpartlen := 0;
  longpartcount  := 0;
  {moved here to prevent compiler warnings}
  if locopt.emailreg then begin
    for counter := 1 to length(parv[2]) do begin
      if not atfound then begin
        if parv[2][counter] = '@' then begin
          atfound := true;
        end else begin
          emailusername := emailusername + parv[2][counter];
        end;
      end else begin
        if parv[2][counter] = '@' then begin
          send(sendtalk+'more than one @ in e-mail address');
          exit;
        end else begin
          emaildomain := emaildomain + parv[2][counter];
          if parv[2][counter] = '.' then begin
            if currentpartlen > 3 then inc(longpartcount);
            currentpartlen := 0;
          end else begin
            inc(currentpartlen);
          end;
        end;
      end;
    end;
    if currentpartlen > 3 then inc(longpartcount);
    if not atfound then begin
      send(sendtalk+'no @ in e-mail address');
      exit;
    end;

    if (not validhost(emaildomain)) or (pos('.',emaildomain) = 0) then begin
      send(sendtalk+'invalid domain part of e-mail');
      exit;
    end;

    {check host against hosts blacklist (localhost and 127.*}
    if not isoper(sptr) then begin
      sl := emailbanlist;
      while sl <> nil do begin
        if maskmatchup(sl.s,parv[2]) then begin
          send(sendtalk+'this email address is blacklisted');
          exit;
        end;
        sl := tstringlinklist(sl.next);
      end;
    end;

  end;
  p := Aaccountlist;
  while p <> nil do begin
    if locopt.emailreg then begin
      if compareemail(parv[2],p.email,longpartcount >= 2) then begin
        // the compiler warns that longpartcound may not have been initalised this is not the case
        if longpartcount >= 2 then begin
          send(sendtalk+'Another e-mail address ending in '+emaildomain+' is in database. Please contact an ircop.' );
        end else begin
          send(sendtalk+parv[2]+' is already in database' )
        end;
        exit;
      end;
    end;
    (*
    -- must be different. using IP throttle list
    if copy(p.hellouser,pos(' ',p.hellouser)+1,32767)=sptr.ip then begin
      send(sendtalk+'Your IP has been used to create an account before. Please contact an ircop.');
      exit;
    end;
    *)
    p := tAaccount(p.next);
  end;

  a := 0;
  p := findAaccount(parv[1]);

  if p <> nil then begin
    send(sendtalk+'account '+p.name+' already exists.');
    exit;
  end else begin
    addAaccount(parv[1],a);
  end;

  authipthrottle_add(sptr.binip,unixtime);

  p := findAaccount(parv[1]);
  //-------------
  assert(assigned(p),'authbot - hello - account not found after creating it','');
    {this code should never run if it does there is a major bug somewhere}
    {thats what i use asserts for - beware}

  p.addmask('*!*@*');
  if locopt.emailreg then begin
    password := randompassword;
    p.email := parv[2];
  end else begin
    password := parv[2];
  end;

  p.password := passnewcrypt(password);
  p.hellouser := sptr.name+'!'+sptr.userid+'@'+sptr.host+'['+ipbintostr(sptr.binip)+']';

  p.lastmailts := unixtime;

  if not locopt.emailreg then begin
    send(sendtalk+'account created successfully');
    exit;
  end;
  // the rest of this procedure only runs if e-mail registration is on

  mail := trequestmailsession.create;
  // storing pointers to users and accounts is dangerous as the account could be
  // deleted by an ircop or the user who was applying for an account could go
  // offline so we store the user by P10 ID and the account by name
  mail.client := sptr.idstr ;
  mail.account := parv[1];

  debugout('abount to call sendmail');


  assert(readtext_init(pt,authmailfile),'failed to open auth mail text',authmailfile);
  mailtext := '';
  fromstr := p.hellouser;
  while not readtext_eof(pt) do begin
    s := readtext_line(pt);
    s := replacealias(s,'%id%',parv[1]);
    s := replacealias(s,'%pass%',password);
    s := replacealias(s,'%anick%',mybot.name);
    s := replacealias(s,'%aserver%',me.name);
    s := replacealias(s,'%fromuser%',fromstr);
    if s = '.' then s := '..';
    mailtext := mailtext + s + #13#10;
  end;
  readtext_close(pt);

  sendmail(locopt.fromemail ,locopt.fromemailrealname,parv[2],
  mailtext,
  locopt.mailserver,
  'your '+mybot.name+' account',
  mail.mailfinished);

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);

  debugout('sendmail complete');

end;

procedure priv_requestpassword(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tAaccount;
  s:string;
  password : string;
  mail : tnewpassmailsession;

  mailtext:string;
  fromstr:string;
  Pt:treadtext;
begin
  if not locopt.emailreg then begin
    send(sendtalk+'function disabled.');
    exit
  end;

  {if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' To request a new password /msg '+mybot.name+' requestpassword <the e-mail addy you used to register with>');
    exit
  end;}

  p := Aaccountlist;
  while p <> nil do begin

    if parv[1]=p.email then begin
      // the compiler warns that longpartcound may not have been initalised this is not the case
      break
    end;

    p := tAaccount(p.next);
  end;
  if p=nil then begin
    send(sendtalk+'email address not in database');
    exit;
  end;

  if (p.lastmailts+locopt.mailthrottle) >= unixtime then begin
    send(sendtalk+'You can''t use '+cmd+' for this email address now. Please wait '+inttostr(p.lastmailts+locopt.mailthrottle - unixtime)+' seconds.');
    exit;
  end;
  p.lastmailts := unixtime;
  if p.level = 0 then begin
    send(sendtalk+'you cannot requestpassword for an account that has never been used');
    exit;
  end;
  password := randompassword;

  mail := tnewpassmailsession.create;
  // storing pointers to users and accounts is dangerous as the account could be
  // deleted by an ircop or the user who was applying for an account could go
  // offline so we store the user by P10 ID and the account by name
  mail.client := sptr.idstr ;
  mail.account := p.name;
{  mail.oldpass := p.password;}
  p.requestedpass := passnewcrypt(password);

  debugout('abount to call sendmail');


  assert(readtext_init(pt,requestpassmailfile),'failed to open auth mail text',requestpassmailfile);
  mailtext := '';
  fromstr := sptr.name+'!'+sptr.userid+'@'+sptr.host+'['+ipbintostr(sptr.binip)+']';
  while not readtext_eof(pt) do begin
    s := readtext_line(pt);
    s := replacealias(s,'%id%',p.name );
    s := replacealias(s,'%pass%',password);
    s := replacealias(s,'%anick%',mybot.name);
    s := replacealias(s,'%aserver%',me.name);
    s := replacealias(s,'%fromuser%',fromstr);
    if s = '.' then s := '..';
    mailtext := mailtext + s + #13#10;
  end;
  readtext_close(pt);

  sendmail(locopt.fromemail ,locopt.fromemailrealname,parv[1],
  mailtext,
  locopt.mailserver,
  'your '+mybot.name+' account',
  mail.mailfinished);

  logaction(sptr,cmd+' '+p.name+' '+parv[1]);

  debugout('sendmail complete');

end;


procedure onprivmsg(nickatserver:boolean;sptr:tuser;target:tuser;s:string;tag:taddrint);
const errormsg='This command is either unknown, or have no access to it.';
var
  parv:tparams;
  parc:integer;
  a,b:integer;
  //bool:boolean;
begin
  nickatservervar := nickatserver;
  parc := strtok(s,' ',@parv);
  cmd := ircupper(parv[0]);
  if cmd = '' then exit;
  sendtalk := sendtalkstr(mybot,sptr);
  b := -1;
  //bool := ismortal(sptr);
  for a := 0 to botmaxcmd do begin
    if cmd = cmdtab[a].customcmd then begin
      if haslevel(sptr) >= cmdtab[a].level then begin
        if cmdtab[a].minparams > parc then begin
          send(sendtalk+replacespecial(cmdtab[a].syntax,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk));

        end else begin
          if @cmdtab[a].p <> nil then cmdtab[a].p(sptr,parc,@parv,s);

        end;
        b := 0;
      end else begin
        b := 1;
      end;
    end;
    //if bool then exit; {LOGIN must be first entry of cmdtable}
  end;
  if b < 0 then begin

    {handle CTCP requests}
    if cmd[1] = #1 then begin
      if cmd = #1'VERSION'#1 then begin
        send(sendtalk+#1'VERSION '+versioninfostr+' '+versionstr+'. authentication service.'#1);
        exit;
      end else
      if copy(cmd,1,5) = #1'PING' then begin
        send(sendtalk+#1'PING '+parv[1]);
        exit;
      end
    end;
    send(sendtalk+errormsg);
  end else if b = 1 then begin
    send(sendtalk+errormsg);
  end;
end;

procedure onstartup;
var
  currentuser : tuser;
begin
  if up then exit;
  up := true;
  currentoperchannel := '';
  authbotinit;
  mybot := addbot(srvunit,locopt.nick,locopt.userid,'',locopt.info,usermode_service or usermode_oper or usermode_deaf);
  prefix := sendprefixstr(mybot);
  if locopt.operchannel <> '' then begin
    bot_join(mybot,locopt.operchannel,true,globaldefaultts);
    sendparse(mybot.idstr+' '+TOK_MODE+' '+locopt.operchannel+' +ntsi');
    currentoperchannel := locopt.operchannel;
  end;
  authbotinit;
  {if we are connected we must iterate through all users logging them in where needed}

  if isconnected then begin
    currentuser := tuser(globaluserlist);

    while assigned(currentuser) do begin
      if currentuser.account <> '' then onaccount(me,currentuser,srvunit.tag);
      currentuser := tuser(currentuser.next);
    end;

  end;
  logaction(nil,'startup');
end;

procedure ontimer;
begin

  debugout('authbot.currentoperchannel='+currentoperchannel);
  debugout('authbot.locopt.operchannel='+locopt.operchannel);
  if opt.autosave <> 0 then if (unixtime >= autosavenextts) then begin
    logaction(nil,'autosave');
    authbotsave;

  end;
  authipthrottle.timehandler;
  //b_gline.timehandler;
end;

procedure onaccount(sptr:tuser;us:tuser;tag:taddrint);
var
  p : taaccount;
begin
  { unfortunately the only way to undo an account we cannot permit is to
   kill the user}
  p := findAaccount(us.account);
  if p = nil then begin
    p := addaaccount(us.account,0);
    logaction(us,'account does not exist: '+us.account);
  end;

  p.lastseents := unixtime;

  us.bottag[srvunit.num] := p;
  {p.user := us;}
  p.adduser(us);

end;

procedure ondestroyuser;
begin
  deauth(us);
  {}
end;

procedure onsendburst;
begin
  {}
end;

procedure ondisconnect;
begin
  {}
end;

procedure onrehash;
begin
  if not up then exit;
  logaction(nil,'Received REHASH signal');
  authbotinit;
end;

procedure authbotshutdown;
begin
  if not up then exit;
  up := false;

  logaction(nil,'shutdown: '+shutdownreason);

  authbotsave;

  //cleargline;
  //clearjupe;

  clearAaccount;

  bot_quit(mybot,shutdownreason);
  mybot := nil;
  currentoperchannel := '';
end;

procedure trequestmailsession.mailfinished(reply : string);
var
  p : taaccount;
  us:tuser;
begin
  //sendtalk := sendtalkstr(mybot,sptr);
  debugout('tmailrequestsession.mailfinished entered');
  us := findnumeric(client);
  sendtalk := sendprefixstr(mybot)+TOK_NOTICE+' '+client+' :';
  if reply[1] = '2' then begin
    if us <> nil then send(sendtalk+'account created and password emailed sucessfully');

  end else begin
    if us <> nil then send(sendtalk+'sending email failed, account '+account+' deleted');
    logaction(us,'sending email failed: '+reply);

    p := findAaccount(account);
    if p <> nil then begin
      linklistdel(tlinklist(Aaccountlist),tlinklist(p));
      p.destroy;
    end;
  end;
  sendflush;
  free;
end;
procedure tnewpassmailsession.mailfinished(reply : string);
var
  p : taaccount;
  us:tuser;
begin
  //sendtalk := sendtalkstr(mybot,sptr);
  debugout('tmailrequestsession.mailfinished entered');

  us := findnumeric(client);

  sendtalk := sendprefixstr(mybot)+TOK_NOTICE+' '+client+' :';
  if reply[1] = '2' then begin
    if us <> nil then send(sendtalk+'Password emailed sucessfully.');
  end else begin
    if us <> nil then send(sendtalk+'Sending email failed.');
    logaction(us,'sending email failed: '+reply);
    p := findAaccount(account);
    if p <> nil then begin
{      p.password := oldpass;}
    end;

  end;
  sendflush;
  free;
end;

procedure reg;
begin
  srvunit := createserviceunit;
  srvunit.name := 'auth';
  srvunit.onstartup := onstartup;
  srvunit.onshutdown := authbotshutdown;
  srvunit.onprivmsg := onprivmsg;
  srvunit.ontimer := ontimer;
  srvunit.onsave := onsave;
  srvunit.onaccount := onaccount;
  srvunit.ondestroyuser := ondestroyuser;
  srvunit.onrehash := onrehash;
  if not registerserviceunit(srvunit) then srvunit.destroy;
end;

begin
  reg;
end.
